# todo: if we cancel in the middle of a btrfs send, then run again immediately, the received subvolume doesn't get a Received UUID: field, and we won't mount it. Need to figure out a solution that will fix this.
-err-bash-trace() {
- local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
- local source
- local extdebug=false
- if [[ $(shopt -p extdebug) == *-s* ]]; then
- extdebug=true
- fi
- for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
- argc=${BASH_ARGC[frame]}
- argc_index+=$argc
- ((frame < start)) && continue
- if (( ${#BASH_SOURCE[@]} > 1 )); then
- source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
- fi
- indent=$((frame-start + 1))
- indent=$((indent < max_indent ? indent : max_indent))
- printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
- if $extdebug; then
- for ((i=argc_index-1; i >= argc_index-argc; i--)); do
- printf " %s" "${BASH_ARGV[i]}"
- done
- fi
- echo \'
- done
- return 0
-}
-err-catch() {
- set -E; shopt -s extdebug
- _err-trap() {
- err=$?
- exec >&2
- set +x
- echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
- err-bash-trace 2
- set -e # err trap does not work within an error trap
- "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
- echo "$0: exiting with code $err"
- exit $err
- }
- trap _err-trap ERR
- set -o pipefail
-}
-err-catch
-
[[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
+source /usr/local/lib/err
usage() {
cat <<'EOF'
sshfail+=($h)
fi
done
- if [[ ! $sshable ]] || { ! $cron && [[ $sshfail ]]; }; then
+ if [[ ! ${sshable[@]} ]] || { ! $cron && [[ ${sshfail[@]} ]]; }; then
die "failed to ssh to hosts: ${sshfail[*]}"
else
- if [[ $sshfail ]]; then
+ if [[ ${sshfail[@]} ]]; then
ret=1
e "error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
fi
d subvol_dir=$subvol_dir
# note, we need $dev because $d might not be mounted, and we do this loop
# because the device in fstab for the rootfs can be different.
- for devx in $(btrfs fi show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
+ for devx in $(btrfs fil show $dev| sed -rn 's#.*path (/\S+)$#\1#p'); do
d devx=$devx
root_dir=$(sed -rn "s,^\s*$devx\s+(\S+).*\bsubvolid=[05]\b.*,\1,p" /etc/mtab /etc/fstab|head -n1)
if [[ $root_dir ]]; then
d "svp=$svp # subvolume path"
snaps=($root_dir/btrbk/$subvol_dir.20*) # Assumes we are in the 21st century.
- if [[ ! $snaps ]]; then
+ if [[ ! ${snaps[@]} ]]; then
# no snapshots yet
echo "$0: warning: no snapshots found at $root_dir/btrbk/$subvol_dir.20*. this is expected for a brand new volume"
continue
# scripts that would interfere with unmounting /a, put them elsewhere
-echo install /a/bin/log-quiet/log-once switch-mail-host btrbk-run mount-latest-subvol check-subvol-stale /usr/local/bin
-install /a/bin/log-quiet/log-once switch-mail-host btrbk-run mount-latest-subvol check-subvol-stale /usr/local/bin
+install /a/bin/log-quiet/log-once switch-mail-host btrbk-run mount-latest-subvol \
+ check-subvol-stale /usr/local/bin
+install /a/bin/errhandle/err /usr/local/lib
cd /
[[ $EUID == 0 ]] || exec sudo -E "$script" "$@"
+source /usr/local/lib/err
usage() {
cat <<EOF
}
-err-bash-trace() {
- local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
- local source
- local extdebug=false
- if [[ $(shopt -p extdebug) == *-s* ]]; then
- extdebug=true
- fi
- for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
- argc=${BASH_ARGC[frame]}
- argc_index+=$argc
- ((frame < start)) && continue
- if (( ${#BASH_SOURCE[@]} > 1 )); then
- source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
- fi
- indent=$((frame-start + 1))
- indent=$((indent < max_indent ? indent : max_indent))
- printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
- if $extdebug; then
- for ((i=argc_index-1; i >= argc_index-argc; i--)); do
- printf " %s" "${BASH_ARGV[i]}"
- done
- fi
- echo \'
- done
- return 0
-}
-err-catch() {
- set -E; shopt -s extdebug
- _err-trap() {
- err=$?
- exec >&2
- set +x
- echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
- err-bash-trace 2
- set -e # err trap does not work within an error trap
- "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
- echo "$0: exiting with code $err"
- exit $err
- }
- trap _err-trap ERR
- set -o pipefail
-}
-err-catch
-
tu() {
while read -r line; do
file="$1"
#!/bin/bash
# usage $0 [MAIL_HOST]
+# setup things which involve being the primary host or not
set -eE -o pipefail
trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
-# setup things which involve being the primary host or not
+
+if [[ ! $SUDO_USER || $EUID == 0 ]]; then
+ echo "$0: error: requires running as nonroot or sudo"
+ exit 1
+fi
if [[ $1 ]]; then
new_host=$1
#!/bin/bash
-err-bash-trace() {
- local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
- local source
- local extdebug=false
- if [[ $(shopt -p extdebug) == *-s* ]]; then
- extdebug=true
- fi
- for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
- argc=${BASH_ARGC[frame]}
- argc_index+=$argc
- ((frame < start)) && continue
- if (( ${#BASH_SOURCE[@]} > 1 )); then
- source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
- fi
- indent=$((frame-start + 1))
- indent=$((indent < max_indent ? indent : max_indent))
- printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
- if $extdebug; then
- for ((i=argc_index-1; i >= argc_index-argc; i--)); do
- printf " %s" "${BASH_ARGV[i]}"
- done
- fi
- echo \'
- done
- return 0
-}
-
-
-err-catch() {
- set -E; shopt -s extdebug
- _err-trap() {
- err=$?
- exec >&2
- set +x
- echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
- err-bash-trace 2
- set -e # err trap does not work within an error trap
- "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
- echo "$0: exiting with code $err"
- exit $err
- }
- trap _err-trap ERR
- set -o pipefail
-}
-err-catch
+source /usr/local/lib/err
usage() {
cat <<EOF
$old_shell sudo systemctl start btrbk.timer
fi
}
-_errcatch_cleanup=cleanup
+_errcatch_cleanup=cleanup # used by sourced err
pre="${0##*/}:"
m() { printf "$pre %s\n" "$*"; "$@"; }